#ifndef __OPENCL_HPP__
#define __OPDNCL_HPP__

#define __CL_ENABLE_EXCEPTIONS
 
#if defined(__APPLE__) || defined(__MACOSX)
#include <OpenCL/cl.hpp>
#else
#include <CL/cl.hpp>
#endif
#include <iostream>
namespace DECS{

    const cl_device_type DEFAULT_DEVICE_TYPE = CL_DEVICE_TYPE_GPU;
    class OpenCL{
    private:
        cl_int error_;
        std::vector<cl::Platform> platforms_;
        std::vector<cl::Device> devices_;
        cl::Context context_;
        cl::CommandQueue queue_;
        cl::Program::Sources source_;
        cl::Program program_;
        cl::Kernel kernel_;
        std::vector<cl::Buffer> argument_;
    protected:
        cl_int setPlatform();
        cl_int setContext();
        cl_int setContext(cl_device_type deviceType);
        cl_int setDevice();
    public:
        OpenCL();
        OpenCL(cl_device_type deviceType);
        ~OpenCL();

        void setSource(std::string& source);
        cl_int buildProgram();
        cl_int setKernel(std::string functionName);
        cl_int setKernelInputArgument(cl_int index, float* argment, const int n);
        cl_int setKernelOutputArgument(cl_int index, const int n);
        cl_int enqueueNDRange(const int n);
        cl_int readBuffer(cl_int index, float* output, const int n);
    };
}

#endif // __OPENCL_HPP__